码迷,mamicode.com
首页 > 其他好文 > 详细

HDU 1025 Constructing Roads In JGShining's Kingdom[动态规划/nlogn求最长非递减子序列]

时间:2018-02-06 23:10:59      阅读:359      评论:0      收藏:0      [点我收藏+]

标签:eve   最大   seve   efi   int   sample   mon   orb   插入   

Constructing Roads In JGShining‘s Kingdom

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 27358    Accepted Submission(s): 7782


Problem Description
JGShining‘s kingdom consists of 2n(n is no more than 500,000) small cities which are located in two parallel lines.

Half of these cities are rich in resource (we call them rich cities) while the others are short of resource (we call them poor cities). Each poor city is short of exactly one kind of resource and also each rich city is rich in exactly one kind of resource. You may assume no two poor cities are short of one same kind of resource and no two rich cities are rich in one same kind of resource.

With the development of industry, poor cities wanna import resource from rich ones. The roads existed are so small that they‘re unable to ensure the heavy trucks, so new roads should be built. The poor cities strongly BS each other, so are the rich ones. Poor cities don‘t wanna build a road with other poor ones, and rich ones also can‘t abide sharing an end of road with other rich ones. Because of economic benefit, any rich city will be willing to export resource to any poor one.

Rich citis marked from 1 to n are located in Line I and poor ones marked from 1 to n are located in Line II.

The location of Rich City 1 is on the left of all other cities, Rich City 2 is on the left of all other cities excluding Rich City 1, Rich City 3 is on the right of Rich City 1 and Rich City 2 but on the left of all other cities ... And so as the poor ones.

But as you know, two crossed roads may cause a lot of traffic accident so JGShining has established a law to forbid constructing crossed roads.

For example, the roads in Figure I are forbidden.

技术分享图片


In order to build as many roads as possible, the young and handsome king of the kingdom - JGShining needs your help, please help him. ^_^
 

 

Input
Each test case will begin with a line containing an integer n(1 ≤ n ≤ 500,000). Then n lines follow. Each line contains two integers p and r which represents that Poor City p needs to import resources from Rich City r. Process to the end of file.
 

 

Output
For each test case, output the result in the form of sample.
You should tell JGShining what‘s the maximal number of road(s) can be built.
 

 

Sample Input
2 1 2 2 1 3 1 2 2 3 3 1
 

 

Sample Output
Case 1: My king, at most 1 road can be built. Case 2: My king, at most 2 roads can be built.
Hint
Huge input, scanf is recommended.
 

 

Author
JGShining(极光炫影)
 

 

Recommend
We have carefully selected several similar problems for you:  1081 1074 1078 1080 1114
[题意]:有n个富饶的城市和n个贫穷的城市,然后每个富饶的城市有一种多余的资源,没有两个城市多余的资源一样, 每个贫穷的城市缺少一种资源,没有两个城市缺少的资源一样,要在他们之间建路,中间不能相交,问最多建几条路 ,当两个城市缺少的和多余的刚好匹配时,就表示能建路,但是建不建不一定
 

[分析]:
假设存在一个序列d[1..9] = 2 1 5 3 6 4 8 9 7,可以看出来它的LIS长度为5。
下面一步一步试着找出它。
我们定义一个序列B,然后令 i = 1 to 9 逐个考察这个序列。
此外,我们用一个变量Len来记录现在最长算到多少了
首先,把d[1]有序地放到B里,令B[1] = 2,就是说当只有1一个数字2的时候,长度为1的LIS的最小末尾是2。这时Len=1
然后,把d[2]有序地放到B里,令B[1] = 1,就是说长度为1的LIS的最小末尾是1,d[1]=2已经没用了,这时Len=1
接着,d[3] = 5,d[3]>B[1],所以令B[1+1]=B[2]=d[3]=5,就是说长度为2的LIS的最小末尾是5,这时候B[1..2] = 1, 5,Len=2
再来,d[4] = 3,它正好加在1,5之间,放在1的位置显然不合适,因为1小于3,长度为1的LIS最小末尾应该是1,长度为2的LIS最小末尾是3,
于是可以把5淘汰掉,这时候B[1..2] = 1, 3,Len = 2
继续,d[5] = 6,它在3后面,因为B[2] = 3, 而6在3后面,于是很容易可以推知B[3] = 6, 这时B[1..3] = 1, 3, 6,还是很容易理解吧? Len = 3.
第6个, d[6] = 4,你看它在3和6之间,于是我们就可以把6替换掉,得到B[3] = 4。B[1..3] = 1, 3, 4,Len继续等于3
第7个, d[7] = 8,它很大,比4大,于是B[4] = 8。Len变成4了
第8个, d[8] = 9,得到B[5] = 9,Len继续增大,到5了。
最后一个, d[9] = 7,它在B[3] = 4和B[4] = 8之间,So最新的B[4] =7,B[1..5] = 1, 3, 4, 7, 9,Len = 5。
于是我们知道了LIS的长度为5。
注意。这个1,3,4,7,9不是LIS,它只是存储的对应长度LIS的最小末尾。有了这个末尾,我们就可以一个一个地插入数据。
虽然最后一个d[9] = 7更新进去对于这组数据没有什么意义,但是如果后面再出现两个数字8和9.那么就可以把8更新到d[5], 9更新到d[6],得出LIS的长度为6。
然后应该发现一件事情了:在B中插入数据是有序的,而且是进行替换而不需要挪动—也就是说,我们可以使用二分查找,
将每一个数字的插入时间优化到O(logN)

 

 
 
[代码]:
技术分享图片
/*
输入一个m,n分别表示成m组,一共有n个数
即将n个数分成m组,
m组的和加起来得到最大值并输出。
*/
#include <bits/stdc++.h>
using namespace std;
const int N=500005;
#define INF 0x7fffffff

int n;
int a[N],dp[N];

int main()
{
    int t=0;
    while(cin>>n)
    {
        int x,y;
        for(int i=1;i<=n;i++)
        {
            scanf("%d%d",&x,&y);
            a[x]=y;
        }
        for(int i=1;i<=n;i++) dp[i]=INF;
        int ans=0;
        for(int i=1;i<=n;i++)
        {
            int tmp=lower_bound(dp+1,dp+n+1,a[i])-dp;
            dp[tmp]=a[i];
            ans=max(ans,tmp);
        }
        printf("Case %d:\nMy king, at most %d road%s can be built.\n\n",++t,ans,ans==1?"":"s");
    }
}
View Code

 

HDU 1025 Constructing Roads In JGShining's Kingdom[动态规划/nlogn求最长非递减子序列]

标签:eve   最大   seve   efi   int   sample   mon   orb   插入   

原文地址:https://www.cnblogs.com/Roni-i/p/8424342.html

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!